
{$IFNDEF WINDOWS}
  Destination :  WINDOWS  !
{$ENDIF}

{$A+,B-,D+,F-,G+,I+,K+,L+,N+,P-,Q-,R-,S+,T-,V+,W+,X+,Y+}
{$M 8192,8192}

Program DEMO_WIN;

uses WinTypes, WinProcs, WinCrt, WinDos;

const DLL = 'MANO_WIN';

function GetDllVersion: Integer; far; external DLL;
function InitComm(COM_NR: Integer): Integer; far; external DLL;
function GetManoID(var M_TYPE, M_SN: Word): Integer; far; external DLL;
function GetValue(CHANNEL: Word; var STATUS: Word; var VALUE: Single; UNIT_CH: PChar): Integer; far; external DLL;
function SetMeasureRate(MINUTES, SECONDS: Word): Integer; far; external DLL;
function GetMeasureRate(var MINUTES, SECONDS: Word): Integer; far; external DLL;
function GetTimeTilNext(var NEXT_CHANNEL, MINUTES, SECONDS: Word): Integer; far; external DLL;
function GetManoTime(var DAYS, HOURS, MINUTES, SECONDS: Word): Integer; far; external DLL;
function GetPeaks(var MAXIMUM, MINIMUM: Single; UNIT_CH: PChar): Integer; far; external DLL;
function SetRecordRate(RATE_BASE, RATE_LO, RATE_HI: Word): Integer; far; external DLL;
function GetRecordRate(var RATE_BASE, RATE_LO, RATE_HI: Word): Integer; far; external DLL;
function SetAmountOfRecords(AMOUNT: Word): Integer; far; external DLL;
function GetAmountOfRecords(var AMOUNT: Word): Integer; far; external DLL;
function InitRecord(var STATUS: Word): Integer; far; external DLL;
function GetRecord(PDATA: PInteger; SIZE_PDATA: Word; var SIZE_READ, STATUS: Word): Integer; far; external DLL;
function GetRecordInfo(var VALID_TM, CHANNEL_TYPE, RATE_BASE, RATE_LO, RATE_HI,
                           DAYS, HOURS, MINUTES, SECONDS: Word): Integer; far; external DLL;
function GetRecordUnit(CHANNEL: Word; UNIT_CH: PChar; var DIVIDER: Word): Integer; far; external DLL;

var
  A                  : Integer;
  B,C,D,E,F,G,H      : Word;
  PDATA, PNEXT, PDISP: PInteger;

  VALUE              : Single;

  SIZE_READ          : Word;

  STATUS             : Word;
  COUNTS             : Word;

  CH_CNT             : Word;
  CHANNEL_TYPE       : Word;
  VALID_TM           : Word;

  POINT              : array[1..3] of Word;
  CH_UNIT            : array[1..3, 0..5] of Char;
  TXT_DISP           : array[1..3] of string;

  REC_DATA           : array[0..10000] of Integer;

  N, M               : Word;
  Ch                 : Char;

begin

  ScreenSize.Y:= 600;
  ScreenSize.X:= 70;

  PDATA:= @REC_DATA;

  Writeln;
  Writeln('---------- DEMO - LOGGER ---------');
  Writeln;

  { output Dll- Versionsnummer }
  Writeln('DLL- Version   : ', GetDllVersion);

  { search Mano }
  A:= InitComm(0);
  Writeln('Mano on COM    : ', A);
  if A <= 0 then Exit;

  { get Type and Serial number }
  A:= GetManoID(B, C);
  Write('ID             : ', A);
  if A < 0 then Exit;
  Writeln('    # Type= ', B,' SN= ', C);

  { prepare for GetRecord }
  A:= InitRecord(STATUS);
  Write('Status         : ', A);
  if A <= 0 then Exit;

  if STATUS = 1 then Writeln('  EE_Pointer ok.')
                else Writeln('  EE_Pointer not ok.');

  COUNTS:= 0;
  PNEXT:= PDATA;

  repeat
    Writeln;
    Writeln('---------------------------------------------------------------------');

    { read Record }
    A:= GetRecord(PNEXT, 10000, SIZE_READ, STATUS);
    Writeln('GetRecord      : ', A, ' SIZE_READ= ', SIZE_READ, ' STATUS=', STATUS);

    Inc(COUNTS, SIZE_READ);

    case A of
      0,  { Mano has been changed }
      -1, { no Mano detected }
      -3, { first call InitRecord }
      -4: { PC memory to small }
        Exit;
      -2: { Communication error, -> repeat }
        Inc(PNEXT, SIZE_READ);
      1:  { ok. }
        case STATUS of
          0, 2: { Time mark Zeitmarke available }
            begin
              { analyze Time mark }
              A:= GetRecordInfo(VALID_TM, CHANNEL_TYPE, B, C, D, E, F, G, H);
              Write('GetRecordInfo  : ', A);
              if A < 0 then Exit;

              Writeln(' VALID_TM= ', VALID_TM, ' CHANNEL_TYPE=', CHANNEL_TYPE);
              Writeln('                   RATE_BASE=', B, ' RATE_LO=', C,' RATE_HI= ', D,
                       ' Time= ', E,':',F,':',G,':',H);

              if VALID_TM = 0 then Exit;

              { How much channels ? }
              CH_CNT:= 3;
              if CHANNEL_TYPE < 11 then CH_CNT:= 2;
              if CHANNEL_TYPE < 2  then CH_CNT:= 1;

              if (COUNTS mod CH_CNT) <> 0 then begin
                Writeln('Recordlength not correct !');
                Exit;
              end;

              { Which kind of measurement ? }
              case CHANNEL_TYPE of
                0, 2, 3, 4, 5, 6, 11, 12, 13, 14, 15, 16, 17:
                  TXT_DISP[1]:= 'p1= ';
                1, 7, 8, 9, 10, 18, 19, 20, 21, 22, 23:
                  TXT_DISP[1]:= 'p1- p2= ';
                else
                  TXT_DISP[1]:= '';
              end;

              case CHANNEL_TYPE of
                2, 11, 12:
                  TXT_DISP[2]:= 'p2= ';
                3, 8, 13, 14, 15, 20, 21, 22:
                  TXT_DISP[2]:= 'Hi= ';
                4, 9:
                  TXT_DISP[2]:= 'Lo= ';
                5, 10, 16, 23:
                  TXT_DISP[2]:= 'T= ';
                6, 17:
                  TXT_DISP[2]:= 'Transmitter= ';
                18, 19:
                  TXT_DISP[2]:= 'p1= ';
                else
                  TXT_DISP[2]:= '';
              end;

              case CHANNEL_TYPE of
                11, 14, 18, 21, 23:
                  TXT_DISP[3]:= 'Lo= ';
                12, 15, 17, 19, 22:
                  TXT_DISP[3]:= 'T= ';
                13:
                  TXT_DISP[3]:= 'p2= ';
                20:
                  TXT_DISP[3]:= 'p1= ';
                else
                  TXT_DISP[3]:= '';
              end;

              { get Unit and Divider }
              for N:= 1 to CH_CNT do
                if GetRecordUnit(N, CH_UNIT[N], POINT[N]) < 0 then Exit;

              { Output }
              PDISP:= PDATA;
              Inc(PDISP, COUNTS);
              COUNTS:= COUNTS div CH_CNT;

              for M:= 1 to COUNTS do begin
                for N:= 1 to CH_CNT do begin
                  VALUE:= PDISP^;
                  VALUE:= VALUE / POINT[N];
                  case POINT[N] of
                    1   : Write(TXT_DISP[N], VALUE:6:0, CH_UNIT[N], '  |  ');
                    10  : Write(TXT_DISP[N], VALUE:6:1, CH_UNIT[N], '  |  ');
                    100 : Write(TXT_DISP[N], VALUE:6:2, CH_UNIT[N], '  |  ');
                    1000: Write(TXT_DISP[N], VALUE:6:3, CH_UNIT[N], '  |  ');
                  end;
                  Dec(PDISP);
                end;
                Writeln;
              end;

              COUNTS:= 0;

            end;
        end;
    end;

    Writeln;
    Writeln(' hit a key (eXit) ... ');
    repeat until Keypressed;
    Ch:= UpCase(ReadKey);
  until CH = 'X';
  DoneWinCrt;
end.